<!DOCTYPE html>
<html lang="en">

<head>
    <title>Task 35.10 - Load All Users </title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>

</body>

</html>
</head>

<body>
    <div class="container-fluid">
        <div>
            <h2 class="text-center p-2" style="color: blue;">DANH SÁCH NGƯỜI DÙNG</h2>
        </div>
        <div class="row form-group">
            <label class="col-sm-2 col-form-label text-right" style="font-weight: bold;">Name</label>
            <div class="col-sm-8">
                <input class="form-control" type="text" id="name-input" placeholder="Nhập tên...">
            </div>
            <div class="col-sm-2">
                <button class="btn btn-danger" id="btn-filter">Lọc User</button>
            </div>
        </div>
    </div>
    <div class="container-fluid">
        <div class="row form-group">
            <div class="col-sm-12 text-nowrap">
                <table class="table table-bordered table-striped table-hover" id="table-user">
                    <thead class="text-white thead-dark">
                        <tr class="text-center">
                            <th scope="col">STT</th>
                            <th scope="col">Name</th>
                            <th scope="col">Username</th>
                            <th scope="col">Email</th>
                            <th scope="col">Address</th>
                            <th scope="col">Zip Code</th>
                            <th scope="col">Phone</th>
                            <th scope="col">Company</th>
                            <th scope="col">Action</th>
                        </tr>
                    </thead>
                    <tbody>

                    </tbody>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    var gUsersArr = [];
    const vBASE_URL = "https://jsonplaceholder.typicode.com/users/";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    $(document).ready(function () {
        onPageLoading();
        $(document).on("click", ".btn-detail", function () {
            console.log("Nút chi tiết được ấn!!");
            console.log("ID:" + $(this).data("userid"));
            const vDETAIL_FORM_URL = "View detail user.html";
            var vUrlToOpenPage = vDETAIL_FORM_URL + "?id=" + $(this).data("userid");
            window.location.href = vUrlToOpenPage;
        });
    });

    // Thêm Even hadlers click và hàm thực thi Filter User
    $("#btn-filter").on("click", onBtnFiltersClick);

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    // Hàm xử lý sự kiện load trang
    function onPageLoading() {
        callApiGetUser();
    };

    // Hàm xử lý nút lọc user
    function onBtnFiltersClick() {
        // debugger;
        // Đối tượng
        var vFilterObject = {
            name: ""
        };
        // b1: thu thập dữ liệu
        readData(vFilterObject);
        // b2: validate ( không cần )
        // b3: thực hiện việc tìm kiếm và xử lý dữ liệu
        var vArrayFilter = findUserByFilter(vFilterObject);
        var vTable = $("#table-user"); // truy vấn bảng table user
        vTable.find("tr:gt(0)").html(""); // xóa trắng bảng (không xóa head)
        if (vArrayFilter.length > 0) {
            // Hiện thông báo đã tìm được
            alert("Tìm thấy " + " " + vArrayFilter.length + " " + "Kết quả phù hợp!");
            // hiển thị danh sách tìm kiếm ra table
            showDataUser(vArrayFilter);
        }
        else {
            alert("Không tìm thấy kết quả phù hợp!!");
            return false;
        }
    };

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    // Hàm call Api get User
    function callApiGetUser() {
        $.ajax({
            url: vBASE_URL,
            type: "GET",
            contentType: "application/json;charset=UTF-8",
            success: function (paramResponse) {
                console.log(paramResponse);
                gUsersArr = paramResponse;
                // Hiển thị dữ liệu
                showDataUser(gUsersArr);
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText);
            }
        });
    };

    // Hàm thu thập dữ liệu
    function readData(paramKeyWordObj) {
        var vInpName = $("#name-input");
        paramKeyWordObj.name = $.trim(vInpName.val());
    };

    //  Hàm xử lý việc tìm kiếm user
    function findUserByFilter(paramKeyWordObj) {
        "use strict";
        const bArrResultObject = [];
        // kiểm tra trường hợp nếu Name được nhập
        if (paramKeyWordObj.name != "") {
            for (let bI = 0; bI < gUsersArr.length; bI++) {
                const bItemUserObj = gUsersArr[bI];
                //  thực hiện so sánh với từ khóa được nhập vào user  
                if ((bItemUserObj.name.toLowerCase().indexOf(paramKeyWordObj.name.toLowerCase())) > -1) {
                    // Thêm đối tượng thỏa mãn điều kiện array
                    bArrResultObject.push(bItemUserObj);
                }
            }
        }
        return bArrResultObject;
    };

    // Hàm hiển thị dữ liệu 
    function showDataUser(paramUserData) {
        for (var bI = 0; bI < paramUserData.length; bI++) {
            // Truy xuất bảng
            var vTable = $("#table-user");
            // Thêm dòng mới cho bảng
            var vNewRow = $("<tr>").appendTo(vTable);
            // Thêm các ô và gắn dữ liệu cho ô
            $("<td>", { html: paramUserData[bI].id }).appendTo(vNewRow);
            $("<td>", { html: paramUserData[bI].name }).appendTo(vNewRow);
            $("<td>", { html: paramUserData[bI].username }).appendTo(vNewRow);
            $("<td>", { html: paramUserData[bI].email }).appendTo(vNewRow);
            $("<td>", { html: paramUserData[bI].address.suite + " " + paramUserData[bI].address.city }).appendTo(vNewRow);
            $("<td>", { html: paramUserData[bI].address.zipcode }).appendTo(vNewRow);
            $("<td>", { html: paramUserData[bI].phone }).appendTo(vNewRow);
            $("<td>", { html: paramUserData[bI].company.name }).appendTo(vNewRow);
            // Ô action
            var vCellAction = $("<td>").appendTo(vNewRow);
            var vButtonDetail = $("<button>", {
                html: "Chi tiết",
                class: "btn btn-success btn-detail",
            })
                .data("userid", paramUserData[bI].id)
                .appendTo(vCellAction);
        };
    };
</script>

</html>